﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;
using HeuristicLab.BioBoost.Representation;
using HeuristicLab.Core;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;

namespace HeuristicLab.BioBoost.Views {

  [Content(typeof (ItemCollection<BioBoostCompoundSolution>), false)]
  public partial class BioBoostSolutionHistoryView : MovieView<BioBoostCompoundSolution> {

    private string firstFileName;
    private readonly SaveFileDialog saveFileDialog = new SaveFileDialog();

    public BioBoostSolutionHistoryView() {
      InitializeComponent();
    }

    protected override void playButton_Click(object sender, EventArgs e) {
      if (saveFileDialog.ShowDialog() == DialogResult.OK) {
        firstFileName = saveFileDialog.FileName;
      }
      base.playButton_Click(sender, e);
    }

    private static readonly Regex FILENAME_REGEX = new Regex(@"(.*)(-\d+)?(\.png)?", RegexOptions.IgnoreCase);

    protected override void trackBar_ValueChanged(object sender, EventArgs e) {
      base.trackBar_ValueChanged(sender, e);
      var solution = viewHost.Content as BioBoostCompoundSolution;
      var view = viewHost.ActiveView as BioBoostCompoundSolutionView;
      if (view != null && solution != null) {
        var filename = firstFileName.Replace(".png", string.Format("-{0:000000}.png", trackBar.Value));
        view.SaveMapViewToPNG(filename);
      }
    }
  }
}
