﻿using System;
using System.Collections.Generic;

namespace HeuristicLab.BioBoost.Views {
  public static class EnumerableExtentions {
    /// <summary>
    /// Returns the index of the first element in source matched by predicate.
    /// </summary>
    public static int IndexOfFirst<T>(this IEnumerable<T> source, Func<T, bool> predicate) {
      int i = 0;
      foreach (T item in source) {
        if (predicate(item)) {
          return i;
        }
        i++;
      }
      return -1;
    }
  }
}
