﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Windows.Forms.VisualStyles;

namespace HeuristicLab.BioBoost.Views {
  public partial class FilterDialog : Form {

    public Regex Regex { get; private set; }
    public bool Keep { get; private set; }

    public FilterDialog() {
      InitializeComponent();
      Keep = true;
    }

    protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
      if (keyData == Keys.Enter) {
        DialogResult = DialogResult.OK;
        Close();
        return true;
      } else if (keyData == Keys.Escape) {
        DialogResult = DialogResult.Cancel;
        Close();
        return true;
      }
      return base.ProcessCmdKey(ref msg, keyData);
    }

    private void textBox1_Validating(object sender, CancelEventArgs e) {
      try {
        Regex = new Regex(textBox1.Text, RegexOptions.IgnoreCase|RegexOptions.IgnorePatternWhitespace);
      } catch (ArgumentException x) {
        textBox1.Select(0, textBox1.Text.Length);
        e.Cancel = true;
        errorProvider1.SetError(textBox1, "not a valid regular expression.");
      }
    }

    private void textBox1_Validated(object sender, EventArgs e) {
      errorProvider1.SetError(textBox1, "");
    }

    private void cancelButton_Click(object sender, EventArgs e) {
      DialogResult = DialogResult.Cancel;
      Close();
    }

    private void okButton_Click(object sender, EventArgs e) {
      DialogResult = DialogResult.OK;
      Close();
    }

    private void keepOption_CheckedChanged(object sender, EventArgs e) {
      Keep = keepOption.Checked;
    }


  }
}
