﻿using GeoAPI.Geometries;
using System.Collections.Generic;

namespace HeuristicLab.BioBoost.Views {
  public static class GeometryExtensions {
    public static IGeometry[] ToArray(this IGeometry geom) {
      var results = new IGeometry[geom.NumGeometries];
      for (int i=0; i<results.Length; i++)
        results[i] = geom.GetGeometryN(i);
      return results;
    }
    public static IEnumerable<IGeometry> GetGeometries(this IGeometry geom) {
      for (int i = 0; i<geom.NumGeometries; i++)
        yield return geom.GetGeometryN(i);
    }
  }
}
