﻿using HeuristicLab.BioBoost.Representation;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using System;

namespace HeuristicLab.BioBoost.Views {

  [StorableClass]
  public class RegionDetailData : ParameterizedNamedItem {

    public override bool CanChangeName { get { return false; } }

    #region Parameters
    public ValueParameter<BioBoostCompoundSolution> SolutionParameter {
      get { return (ValueParameter<BioBoostCompoundSolution>) Parameters["Solution"]; }
    }
    public ValueParameter<StringValue> RegionNameParameter {
      get { return (ValueParameter<StringValue>) Parameters["RegionName"]; }
    }
    #endregion

    #region Parameter Values
    public BioBoostCompoundSolution Solution {
      get { return SolutionParameter.Value; }
      set { SolutionParameter.Value = value;  }
    }
    public String RegionName {
      get { return RegionNameParameter.Value.Value; }
      set { RegionNameParameter.Value.Value = value; }
    }
    #endregion

    [StorableConstructor]
    protected RegionDetailData(bool isDeserializing) : base(isDeserializing) {}
    protected RegionDetailData(RegionDetailData orig, Cloner cloner) : base(orig, cloner) {}
    public RegionDetailData() {
      Parameters.Add(new ValueParameter<BioBoostCompoundSolution>("Solution", "The solution from which the detail should be obtained."));
      Parameters.Add(new ValueParameter<StringValue>("RegionName", "The name of the region for which details show be displayed."));
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new RegionDetailData(this, cloner);
    }

  }
}
